ASSEMBLE
	LISTM
RPL
**********************************************************************
* Modulname:	JAZZ
* Author:	Mika Heiskanen
* Address:	JMT 7 C 355, 02150 ESPOO, FINLAND
* Email:	mheiskan@alpha.hut.fi
* Edition History:
*	1.0	03.06.1994	Merged asslib and dislib
*		18.09.1994	Fixed IncludeBack not to get tab?
*				Fixed cycles for 81* instructions
*				MKTAB adds "00000" terminator (untested)
*				Added ROMPTR name recognition
*				Added 002/700 Rom-Word decompilation
*				Changed sPACK to mean sTABU
*				Fixed <ddd> to be interpreted as <ddd>
*				Fixed error message (position number)
*				Added new arguments for DOB
*		05.10.1994	Fixed ?rBIT= cycle count
*				Added SafeSkipOb to fix ACPTR handling
*				Fixed scanner timeout to 10 minutes
*				Changed EQU and = to be of absolute values
*				(Should be according to expression!!)
*		06.11.1994	Added ED,EC,VV,SSTK,SDB
*				Fixed EQU to cause no error for duplicate
*				symbols if value is the same
*				Fixed CK&DISPATCH2 to use sst_rcola
*
* Known bugs:
*		- Off key in ED/EC/VV
*		- CK<n>&Dispatch doesn't work for lists in G/GX
* To do:
*	- MAKEROM Tokens for ASS
*	- Library decompiler
**********************************************************************

**********************************************************************
*		Config & Message table
**********************************************************************

xROMID	3E0	( 992 )

ASSEMBLE
ROMID#	EQU #3E0
=xxCONFIG
RPL

:: [#] ROMID# TOSRRP ;

	INCLUDE msgtab.s

**********************************************************************
*		External Definitions
**********************************************************************

* display

EXTERNAL	xFNT1
EXTERNAL	xFNT2

* assmain.s

EXTERNAL	xASS
EXTERNAL	Assemble
EXTERNAL	MakeAssStat$
EXTERNAL	SetupAssOps

* dismain.s

EXTERNAL	xDIS
EXTERNAL	xDISXY
EXTERNAL	xDOB
EXTERNAL	Dob
EXTERNAL	xDISN

EXTERNAL	Diss
EXTERNAL	SetDissOps
EXTERNAL	SetDisXYOps
EXTERNAL	SetDisnOps
EXTERNAL	SetStkDis1Ops

EXTERNAL	ScanLabels	( $status --> $status $labels )
EXTERNAL	ScanLabsXY	( $status --> $status $labels )
EXTERNAL	AddLabsRPL	( $labels #x #y --> $labels' )
EXTERNAL	AddLabsXY	( $labels #x #y --> $labels' )

EXTERNAL	FindObEnd	( #x --> #x #y TRUE / #x FALSE )
EXTERNAL	SkipMLN
* db.s
EXTERNAL	xDB
* sdb.s
EXTERNAL	xSDB
EXTERNAL	xSHALT
EXTERNAL	SdbStart
EXTERNAL	SdbName
EXTERNAL	SdbRomp
EXTERNAL	SdbSeco
EXTERNAL	RUI
EXTERNAL	RUIHALT
EXTERNAL	SdbMenu
EXTERNAL	SdbCheckMe
EXTERNAL	SdbDoMode
EXTERNAL	SdbThisMode
EXTERNAL	SdbFinish
EXTERNAL	SdbEval
EXTERNAL	SdbRstkDisp
EXTERNAL	RPICK
EXTERNAL	SdbD0Disp
EXTERNAL	SdbLamDisp
EXTERNAL	SdbDispLam
EXTERNAL	GetLamEnv!
EXTERNAL	GetLamEnv
EXTERNAL	SdbLoopDisp
EXTERNAL	Pad$
EXTERNAL	GetLoopEnv
EXTERNAL	SdbExec
EXTERNAL	SdbSkip
EXTERNAL	SdbDbCode
EXTERNAL	SdbSemi
EXTERNAL	SdbInOb
EXTERNAL	SdbInId
EXTERNAL	SdbInThis

EXTERNAL	SdbSstSemi
EXTERNAL	SdbSstOb
EXTERNAL	sst_rpite
*EXTERNAL	sst_decr
EXTERNAL	sst_exam
EXTERNAL	sst_rprot
EXTERNAL	sst_reval:
EXTERNAL	sst_rcola
EXTERNAL	sst_cola
EXTERNAL	sst_raddtop
EXTERNAL	sst_addtop
EXTERNAL	sst_ntrap
EXTERNAL	sst_dtrap
EXTERNAL	sst_status?

* ea.s
EXTERNAL	xEA
EXTERNAL	#>Entr
EXTERNAL	Entr>#
* rtab.s
EXTERNAL	xRTAB
EXTERNAL	xDTAB
EXTERNAL	GetRplTab
EXTERNAL	GetDisTab
EXTERNAL	RclID
* mkrtab.s
EXTERNAL	xRTB\8D
EXTERNAL	x\8DRTB
* mkdtab.s
EXTERNAL	x\8DDTB
* parmain.s
* memory.s
EXTERNAL	SG_ITE
EXTERNAL	SX?
EXTERNAL	CHECKME
EXTERNAL	TOTEMPBOT?
* ec.s
EXTERNAL	xEC
* view.s
EXTERNAL	xED
EXTERNAL	DoEd
EXTERNAL	xVV
* stk.s
EXTERNAL	xSSTK
EXTERNAL	SSTKLOOP
EXTERNAL	ModSStkKey
EXTERNAL	SysDisplay!
EXTERNAL	?DispStack!
EXTERNAL	DispStack!
EXTERNAL	DispStack1!
EXTERNAL	DispLevel!
EXTERNAL	StkDis1
* istk.s
EXTERNAL	IStk
EXTERNAL	IStkDisp
EXTERNAL	?DispIStk
EXTERNAL	IStkKeys
EXTERNAL	IStkUp&Rep
EXTERNAL	IStkDn&Rep
EXTERNAL	IStkPgUp
EXTERNAL	IStkPgDn
EXTERNAL	IStkFarUp
EXTERNAL	IStkFarDn
EXTERNAL	IStkMenu
EXTERNAL	IStkDoN:
EXTERNAL	IStkMenuEd
EXTERNAL	IStkView
EXTERNAL	IStkIView
EXTERNAL	IStkEdit
EXTERNAL	IStkVisit
EXTERNAL	IStkDrop
EXTERNAL	?AdjSel/Exit!
EXTERNAL	?AdjSelPos!
EXTERNAL	ShowSel!
EXTERNAL	UnShowSel!
EXTERNAL	>SelPict!

* scanner.s

*EXTERNAL	xSC

**********************************************************************
*		Global Definitions
**********************************************************************

	INCLUDE	keydefs.h
ASSEMBLE
	INCLUDE	gentries.a	* Unsupported entries
	INCLUDE	gmacros.a	* Global macros
*	INCLUDE	par/pardefs.a	* RPLpar Structure
	INCLUDE	dis/disdefs.a	* DISS definitions
	INCLUDE	ass/assdefs.a	* ASS definitions
	INCLUDE	dbg/dbdefs.a	* MDB definitions
RPL
**********************************************************************
*		JAZZ Subroutines
**********************************************************************

	INCLUDE	display/font1.s		( 4x6 font )
	INCLUDE	display/font2.s		( 6x8 font )
	INCLUDE	display/display.s	( Display subroutines )
	INCLUDE	misc/memory.s		( Memory subroutines )
	INCLUDE	ass/ass.s		( Assembler )
ASSEMBLE
	INCLUDE	misc/safeskip.a		( SafeSkipOb )
RPL
	INCLUDE	dis/dis.s		( Disassembler )
	INCLUDE	dbg/db.s		( ML Debugger )
	INCLUDE	sdbg/sdb.s
	INCLUDE tab/ea.s		( EA command )
	INCLUDE	tab/rtab.s		( RTAB & DTAB )
	INCLUDE	tab/mkrtab.s		( RTAB-> and ->RTAB )
	INCLUDE	tab/mkdtab.s		( ->DTAB )
*	INCLUDE	par/par.s		( RPLpar handling )
	INCLUDE	ec/ec.s			( Entries Catalog )
	INCLUDE	edit/ed.s		( ED )
	INCLUDE	edit/view.s		( VV )
	INCLUDE	stk/stk.s		( RPL Stack )
	INCLUDE	stk/istk.s		( Interactive stack )
*	INCLUDE	scanner/scanner.s	( Memory Scanner )

**********************************************************************

